aboutsummaryrefslogtreecommitdiffstats
path: root/scripts/make_device_config.sh
diff options
context:
space:
mode:
authorfishsoupisgood <github@madingley.org>2019-04-29 01:17:54 +0100
committerfishsoupisgood <github@madingley.org>2019-05-27 03:43:43 +0100
commit3f2546b2ef55b661fd8dd69682b38992225e86f6 (patch)
tree65ca85f13617aee1dce474596800950f266a456c /scripts/make_device_config.sh
downloadqemu-master.tar.gz
qemu-master.tar.bz2
qemu-master.zip
Initial import of qemu-2.4.1HEADmaster
Diffstat (limited to 'scripts/make_device_config.sh')
-rw-r--r--scripts/make_device_config.sh30
1 files changed, 30 insertions, 0 deletions
diff --git a/scripts/make_device_config.sh b/scripts/make_device_config.sh
new file mode 100644
index 00000000..c1afb3ff
--- /dev/null
+++ b/scripts/make_device_config.sh
@@ -0,0 +1,30 @@
+#! /bin/sh
+# Writes a target device config file to stdout, from a default and from
+# include directives therein. Also emits Makefile dependencies.
+#
+# Usage: make_device_config.sh SRC DEPFILE-NAME DEPFILE-TARGET > DEST
+
+src=$1
+dep=$2
+target=$3
+src_dir=`dirname $src`
+all_includes=
+
+process_includes () {
+ cat $1 | grep '^include' | \
+ while read include file ; do
+ all_includes="$all_includes $src_dir/$file"
+ process_includes $src_dir/$file
+ done
+}
+
+f=$src
+while [ -n "$f" ] ; do
+ f=`cat $f | tr -d '\r' | awk '/^include / {printf "'$src_dir'/%s ", $2}'`
+ [ $? = 0 ] || exit 1
+ all_includes="$all_includes $f"
+done
+process_includes $src
+
+cat $src $all_includes | grep -v '^include'
+echo "$target: $all_includes" > $dep